; FASTOFF2.ASM - TURNS OFF DISKETTE DRIVE MOTOR MUCH QUICKER
; =========================================================
BIOS_SEG       SEGMENT AT 40H          ;ESTABLISH BIOS SEG
         ASSUME CS:BIOS_SEG
         ORG    0040H
MOTOR_COUNT:    DB    ?
BIOS_SEG       ENDS
;
CSEG     SEGMENT
         ASSUME CS:CSEG
         ORG    100H
START:   JMP SHORT INITIAL
ROM_INT8 DD     ?                      ;ORIG TIMER INT VEC ADD
;
INT8     PROC    FAR
         ASSUME  CS:CSEG, DS:BIOS_SEG
         PUSH    DS
         PUSH    AX
         MOV     AX,BIOS_SEG           ;GET BIOS DATA SEG
         MOV     DS,AX                 ;ADDRESSABILITY
;
         CMP BYTE PTR MOTOR_COUNT,32H  ;IS IT VERY HIGH
         JB      RETURN                ;NO, CONTINUE
         MOV BYTE PTR MOTOR_COUNT,32H  ;IF YES, SET LOWER
;
RETURN:
         POP     AX
         POP     DS
         JMP     ROM_INT8              ;GO TO ORIGINAL TIMER ROUTINE
INT8     ENDP
;*********************************************************************
INITIAL:
         ASSUME  CS:CSEG, DS:CSEG
;
         MOV     AX,3508H              ;GO GET OLD VECTOR
         INT     21H
;
         MOV WORD PTR [ROM_INT8] ,BX   ;SAVE OLD VECTOR OFFSET
         MOV WORD PTR [ROM_INT8+2],ES  ;SAVE OLD VECTOR SEGMENT
;
         MOV     DX,OFFSET INT8        ;SETUP TO CHANGE VECTOR
         MOV     AX,2508H
         INT     21H
;
         MOV     DX,OFFSET INITIAL     ;SETUP TSR
         INT     27H
CSEG     ENDS
         END     START
